typedef enum position { O, U } position;
typedef struct crossing {
  int n;
  position p;
  int s;
} crossing;
//typedef unsigned char codeelem;
typedef unsigned short codeelem; // unfortunately, this is needed now
typedef struct code {
  codeelem *code;
  signed char n;
  //int lowest;
} code;

typedef unsigned int knot; // should be either unsigned int or long long
#include <limits.h>
#define KNOT_MAX UINT_MAX
#define KNOT_PRINTF "%u"

extern crossing *crossings;
extern int cyclic;
extern int reversible;

void initcrossings(int);
code *gencodes(int, int *);
code *genallcodes(int, knot *);
code getcode(code *, int, knot);
int getsigns(code);
code rotate(code);
code first(code);
int compare(code, code);
int compare2(code, code, int);
int find(code, code *, int, int);
void printcode(code);
char *sprintcode(code);
code parsecode(char *);
code simplify(code);
