typedef struct poly {
  int *coeffs;
  int n; // number of coefficients
  int m; // coeffs[i] = a --> aA^(i+m)
} poly;

typedef struct twopoly { //terms[i]=p(s) -> t^(i+m)*p(s) (terms are polys in s)
  poly *terms;
  int n;
  int m;
} twopoly;

poly jonespoly(code);
poly jonespoly2(code);
poly multijonespoly(code, int);
poly jonesmirror(poly);
int Jinvar(code);
twopoly genalexander(code);
twopoly genalexhmirror(twopoly);
twopoly genalexvmirror(twopoly);
void freetwopoly(twopoly);
void printpoly(poly);
char *sprintpoly(poly);
char *sprintjones(poly);
void printtwopoly(twopoly);
char *sprinttwopoly(twopoly);
int comparepoly(poly, poly);
int comparetwopoly(twopoly, twopoly);
void initpascal(int);
